<style>
  .jstree-default > .jstree-striped {
    width: 100%;
  }
  /*.jstree-node>a {
    width: calc(100% - (200px + 1px + 4px));
    text-overflow: ellipsis;
    overflow: hidden;
  }*/
</style>

<h4><%= Admin::Perimeter.model_name.human.pluralize %></h4>

<div id="tree_content_ajaxtree" style='padding-top: 5px;'>
  <button class="btn" id="expand_perimeter_tree" type='input'><%= t('.expend')%></button>
  <button class="btn" id="collapse_perimeter_tree"><%= t('.collapse') %></button>

  <div id='tree_zone'>
    <div id="js_tree_perimeter"></div>
  </div>
  <br>
</div>

<script>
  $(function(){
    mytree = $('#js_tree_perimeter')
    .bind("loaded.jstree", function (e, data) {
        data.instance.open_all();
    })
    .bind("refresh.jstree", function (e, data) {
        data.instance.open_all();
    })
    .jstree({
        "plugins" : [ "themes", "dnd", "state", "types", "wholerow", "sort", "search"], //, "stackedicon" ],  //
        "themes" : {
            "theme" : "default",
            "icons" : false
        },
        "core": {
            "animation" : 0 ,
            "check_callback" :  function (operation, node_obj, node_parent, node_position, more) {
                                  // Pour empêcher le déplacement de type reorder
                                  if (more && more.dnd && more.pos !== "i") { return false; }
                                  // D&D
                                  if (operation === "move_node") {
                                    return true
                                  }
                                  return true;
                                },
            "themes" : { "stripes" : true },
            "multiple" : false,
            "data" : { "url" : '<%= Rails.application.routes.url_helpers.admin_perimeters_js_tree_data_path(locale: I18n.locale) %>',
                       "data" : function(node) {
                                return { 'id' : node.id };
                            }
                     }
        },
        //"dnd" : { "copy": false, "use_html5" : true, "insid e_pos" : "last" },
        "types" : {
                    "#" : { "icon": "fas fa-universal-access icon_tree_tag" },
                    'perimeter': { "icon": "fas fa-map-marker icon_tree_tag" }
                  },
        // Tri les élems par ID => même ordre que dans la BDD
        "sort" : function (a, b) { return (parseInt(a) < parseInt(b)) ? -1 : 1; }
    })
    // Drag & Drop : déplacement d'un perimeter dans l'arbre
    .bind("move_node.jstree", function(e, data) {
      console.log("Déplacement du node " + data.node.id + " vers " + data.parent);
      let url = $("#"+data.node.id+"_link").attr('data-fct-dnd');
      console.log(url);

      let datas = {};
      datas = {'admin_perimeter': { 'parent_id': data.parent}}
      $.ajax({
        url: url,
        type: 'PATCH',
        data: datas,
        dataType: 'script',
        beforeSend: function(xhr) {xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));},
        success: function(data) {
          console.log('Update done.');
        }
      });
      data.instance.open_node(data.parent);
    })

    $('#expand_perimeter_tree').on("click", function() {
      $("#js_tree_perimeter").jstree("open_all");
    });
    $('#collapse_perimeter_tree').on("click", function() {
      $("#js_tree_perimeter").jstree("close_all");
    });
  });
</script>
